unit Unit3;

interface

uses windows, graphics, sysutils, messages, unit1;

const OFN_EXPLORER = $00080000;
      OFN_NONETWORKBUTTON = $00020000;
      OFN_HIDEREADONLY = $00000004;
      ar:array[0..1]of Shortint =(-1,1);//   
      b1x=7;   //      
      b1y=7;
      b1w=75;
      b1h=25;

      b2x=7;   c1x=7;    c3x=7;    c5x=7;     e1x=428;
      b2y=40;  c1y=105;  c3y=168;  c5y=126;   e1y=7;
      b2w=75;  c1w=60;   c3w=60;   c5w=60;    e1w=110;
      b2h=25;  c1h=20;   c3h=20;   c5h=20;    e1h=433;

      b3x=7;   c2x=7;    c4x=7;    c6x=7;
      b3y=73;  c2y=147;  c4y=189;  c6y=210;
      b3w=75;  c2w=60;   c4w=60;   c6w=60;
      b3h=25;  c2h=20;   c4h=20;   c6h=20;

type
 RZLT = record
  chr:char; //  
  Pver:extended;//   
  ver:extended; // 
  ang:extended; //  
 end;

 trgb = record  //,      ,     
  b,g,r: byte;
 end;

 ARGB = array [0..0] of TRGB;
 PARGB = ^ARGB;

 poin = record
  x,y:extended; // . 
  dx,dy:extended;//   
  mass:cardinal; //  ,   
 end;

 rec = record
  w,h:cardinal; //  / 
  centr:poin;// ,    ""
  delta:extended; //       
  color:trgb; //    
 end;

  expoint = record   //   
   X:extended;
   Y:extended;
  end;

 tagOFNA = packed record
  lStructSize: DWORD;
  hWndOwner: HWND;
  hInstance: HINST;
  lpstrFilter: PAnsiChar;
  lpstrCustomFilter: PAnsiChar;
  nMaxCustFilter: DWORD;
  nFilterIndex: DWORD;
  lpstrFile: PAnsiChar;
  nMaxFile: DWORD;
  lpstrFileTitle: PAnsiChar;
  nMaxFileTitle: DWORD;
  lpstrInitialDir: PAnsiChar;
  lpstrTitle: PAnsiChar;
  Flags: DWORD;
  nFileOffset: Word;
  nFileExtension: Word;
  lpstrDefExt: PAnsiChar;
  lCustData: LPARAM;
  lpfnHook: function(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): UINT stdcall;
  lpTemplateName: PAnsiChar;
 end;

var
  MainWND:thandle;
  hFontBold: THandle;
  WC: TWndClass;
  Mesg:TMsg;
  but1,but2,but3,
  ch1, // / 
  ch2, //  
  ch3, //
  ch4, //  - 
  ch5, //tochki
  ch6, //circle
  ed1: // 
  THandle;

  sour, sha: tbitmap; //,   
  px,py: integer; //    
  prevx, prevy: integer; //      
  Rprevx, Rprevy: integer; //       
  drawtrig: boolean = false;
  dragtrig: boolean = false;
  filename:string;
  ps,pr:array of PARGB;  //       Pointer Sours, Pointer Result
  shad:integer;
  orw,orh:integer; //      
  unic: array of tpoint;
  points: array of poin;
  pointsCOPY: array [0..2] of array of poin;//    6 ,    3 
  pCOPYcount:integer; //   pointsCOPY
  plot: array [0..5] of integer; //       ""
  plotcount:integer; //   
  rects: array of rec;
  circ: array of tpoint; //      
  activ, trig, rn:boolean;//    
  wrt,grt,r1,r2:trect;   //Work RecT (  ) Graphic RecT
  count:cardinal;
  Thr: longword;
  ofn: tagOFNA;
  oFilterIndex: DWORD;
  walls, col, tochki, circle, square:boolean; //   /   
  gravity:integer;
  MassCentr:tpoint; // 
  MaxFar:integer;  //    ()   
  prevMAXunic,MAXunic:int64;//   ""
  t1,t2,t3:int64; //    
  b2cap:array [0..4999] of char; //  ""   
  step:integer; //  
  invariant:array [0..99] of extended;
  maxinv:extended;

function GetMid(t:trect):trgb;
procedure GetMassCenter;
procedure Concrete(rect:trect);
procedure Concrete2(rect:trect; s:char);
procedure DrawFrame(c:boolean);
procedure DrawCircle(r,g,b:byte); //    
procedure UppendText(str:string);
function Ang2Point(angle:extended;R:extended):expoint;
procedure GetResult;

implementation

procedure GetResult;
 var x:array[0..high(Etalons)]of RZLT;
     vers: array [0..high(Etalons[0])]of extended;
     i,j,c,n,k:integer;
     min:extended;
     tmp:RZLT;
     t:boolean;
begin
 for i:=0 to high(Etalons) do begin //  
  for n:=0 to high(Etalons[0]) do begin // 100 
   vers[n]:=0;
   for c:=0 to high(Etalons[0]) do begin
    j:=c+n;
    k:=j;
    if j>high(Etalons[0]) then
     k:=j-high(Etalons[0])-1;
    vers[n]:=vers[n]+abs(invariant[c]-etalons[i][k]);
   end;
  end;
  min:=1e8;
  c:=0; // 
  for j:=0 to high(vers) do
   if vers[j]<min then begin
    min:=vers[j];
    c:=j
   end;
  x[i].chr:=Alph[i];
  x[i].ver:=min;
  x[i].ang:=c*3.6;
  if x[i].ang>180 then x[i].ang:=180-(x[i].ang-180)
                  else x[i].ang:=-x[i].ang;
 end;

 repeat
  t:=false;
  for i:=0 to high(Etalons)-1 do begin
   if x[i+1].ver<x[i].ver then begin
    tmp.chr:=x[i].chr;
    tmp.Pver:=x[i].Pver;
    tmp.ver:=x[i].ver;
    tmp.ang:=x[i].ang;

    x[i].chr:=x[i+1].chr;
    x[i].Pver:=x[i+1].Pver;
    x[i].ver:=x[i+1].ver;
    x[i].ang:=x[i+1].ang;

    x[i+1].chr:=tmp.chr;
    x[i+1].Pver:=tmp.Pver;
    x[i+1].ver:=tmp.ver;
    x[i+1].ang:=tmp.ang;
    t:=true;
   end;
  end;
 until t=false;

 setwindowtext(ed1,''); // 
 FillMemory(@b2cap[0],5000,0);
 for i:=0 to high(Etalons) do begin
  UppendText(x[i].chr+' / '+
            format('%.2f',[x[i].ver])+' / '+
            format('%.2f',[x[i].ang])+''{+#13#10});
 end;
end;

function Ang2Point(angle:extended;R:extended):expoint;// 0-360,   12:00   ,  -      R
 var z:integer;
begin
 if angle>=360 then angle:=0; //   
 z:=trunc(angle/180);
 case z of
 0:begin
   result.X:=r*-sin(pi*angle/180);
   result.Y:=r*cos(pi*angle/180);
  end;
 1:begin
   angle:=angle-180*z;
   result.X:=r*sin(pi*angle/180);
   result.Y:=r*-cos(pi*angle/180);
  end;
 end;
end;

procedure UppendText(str:string);
 var i,z:integer;
begin
 getwindowtext(ed1,b2cap,5000);
 z:=0;
 for i:=0 to 4999 do if b2cap[i]=#0 then begin z:=i; break; end;
 for i:=1 to length(str) do
  b2cap[i-1+z]:=str[i];
 b2cap[z+length(str)]:=#13;
 b2cap[z+length(str)+1]:=#10;
 setwindowtext(ed1,b2cap);
end;

function GetMid(t:trect):trgb;                
 var i,j:integer;
     r,g,b:int64;
begin
 r:=0;
 g:=0;
 b:=0;
 for i:=t.Top to t.Bottom do
  for j:=t.Left to t.Right do begin
   r:=r+ps[i,j].r;
   g:=g+ps[i,j].g;
   b:=b+ps[i,j].b;
  end;
 i:=(t.Bottom-t.Top+1)*(t.Right-t.Left+1);
 result.r:=r div i;
 result.g:=g div i;
 result.b:=b div i;
end;

procedure DrawCircle(r,g,b:byte);
 var i:integer;
begin
 for i:=0 to high(circ) do begin
  ps[circ[i].y,circ[i].x].r:=r;
  ps[circ[i].y,circ[i].x].g:=g;
  ps[circ[i].y,circ[i].x].b:=b;
 end;
end;

procedure DrawFrame(c:boolean);
 var i,n,m,x,y,x1,y1:integer;
 d1:hdc;
begin
 sour.Canvas.FillRect(grt);
// if circle and c then DrawCircle(255,0,0); //        
 
 if tochki then begin
  for i:=0 to high(points) do begin   // 
   x:=round(points[i].x);
   y:=round(points[i].y);
   if (y>0)and(x>0)and(y<orh)and(x<orw) then begin
    ps[y,x].r:=0;
    ps[y,x].g:=0;
    ps[y,x].b:=0;
   end;
  end;
 end else begin                       // 
  for i:=0 to high(rects) do begin
   y:=round(rects[i].centr.y-rects[i].delta);
   x:=round(rects[i].centr.x-rects[i].delta);
   for n:=0 to rects[i].h do
    for m:=0 to rects[i].w do begin
     y1:=y+n;
     x1:=x+m;
     if (y1>0)and(x1>0)and(y1<orh)and(x1<orw) then begin
      ps[y1,x1].r:=rects[i].color.r;
      ps[y1,x1].g:=rects[i].color.g;
      ps[y1,x1].b:=rects[i].color.b;
     end;
    end;
  end;
 end;

 d1:=getdc(mainwnd);
 bitblt(d1,px+1,py+1,orw,orh,sour.Canvas.Handle,1,1,srccopy); //  
 releasedc(mainwnd,d1);
end;

procedure Concrete(rect:trect);
 function GetMiddle(t:trect):extended;
  var i,j:integer;
 begin
  result:=0;
  for i:=t.Top to t.Bottom do
   for j:=t.Left to t.Right do
    result:=result+ps[i,j].r;
  result:=result/((t.Bottom-t.Top+1)*(t.Right-t.Left+1));
 end;
                                                    
 var bal:extended;                    // 1 2
     rec1,rec2,rec3,rec4,rec5:trect;  // 3 4
     w,h:integer; 
     trigger:boolean;
begin
 trigger:=false; //     
 w:=rect.Right-rect.Left; //     (-1)
 h:=rect.Bottom-rect.Top;
 if w>h then begin //     , ...
  rec5.Right:=rect.Right;
  rect.right:=rect.Left+h; //    
  trigger:=true;
  rec5.Left:=rect.right+1; //    
  rec5.Top:=rect.Top;
  rec5.Bottom:=rect.Bottom;
  w:=h;
 end;
 if w<h then begin
  rec5.Bottom:=rect.Bottom;
  rect.Bottom:=rect.Top+w;
  trigger:=true;
  rec5.Left:=rect.Left;
  rec5.Top:=rect.Bottom+1;
  rec5.Right:=rect.Right;
  h:=w;  
 end;

 bal:=GetMiddle(rect); //     R  

 if bal=0 then begin  //   
  setlength(rects,length(rects)+1); //  
  rects[high(rects)].w:=w;
  rects[high(rects)].h:=h;
  rects[high(rects)].delta:=w/2;
  rects[high(rects)].centr.x:=rect.Left+rects[high(rects)].delta;
  rects[high(rects)].centr.y:=rect.Top+rects[high(rects)].delta;
  rects[high(rects)].centr.mass:=(w+1)*(h+1);
  rects[high(rects)].centr.dx:=0;
  rects[high(rects)].centr.dy:=0;
  if col then begin
   rects[high(rects)].color.r:=random(220);
   rects[high(rects)].color.g:=random(220);
   rects[high(rects)].color.b:=random(220);
  end else begin
   rects[high(rects)].color.r:=0;
   rects[high(rects)].color.g:=0;
   rects[high(rects)].color.b:=0;
  end;

  if trigger then Concrete(rec5);
  exit;
 end;

 if bal=255 then begin   // 
  if trigger then Concrete(rec5);
  exit;
 end;

 rec1.Top:=rect.Top;
 rec1.Left:=rect.Left;
 rec1.Right:=rec1.Left+(w div 2);
 rec1.Bottom:=rec1.Top+(h div 2);

 rec2.Top:=rect.Top;
 rec2.Left:=rec1.Right+1;
 rec2.Right:=rect.Right;
 rec2.Bottom:=rec1.Bottom;

 rec3.Top:=rec1.Bottom+1;
 rec3.Left:=rect.Left;
 rec3.Right:=rec1.Right;
 rec3.Bottom:=rect.Bottom;

 rec4.Top:=rec3.Top;
 rec4.Left:=rec2.Left;
 rec4.Right:=rect.Right;
 rec4.Bottom:=rect.Bottom;

 concrete(rec1);
 concrete(rec2);
 concrete(rec3);
 concrete(rec4);

 if trigger then Concrete(rec5);
end;

procedure Concrete2(rect:trect; s:char);
 function GetMiddle(t:trect):extended;
  var i,j:integer;
 begin
  result:=0;
  for i:=t.Top to t.Bottom do
   for j:=t.Left to t.Right do
    result:=result+ps[i,j].r;
  result:=result/((t.Bottom-t.Top+1)*(t.Right-t.Left+1));
 end;

 var bal:extended;
     rec1,rec2:trect;
     w,h:integer; 
begin
 w:=rect.Right-rect.Left; //     (-1)
 h:=rect.Bottom-rect.Top;
 
 bal:=GetMiddle(rect); //     R  

 if bal=0 then begin  //   
  setlength(rects,length(rects)+1); //  
  rects[high(rects)].w:=w;
  rects[high(rects)].h:=h;
  rects[high(rects)].delta:=w/2;
  rects[high(rects)].centr.x:=rect.Left+rects[high(rects)].delta;
  rects[high(rects)].centr.y:=rect.Top+rects[high(rects)].delta;
  rects[high(rects)].centr.mass:=(w+1)*(h+1);
  rects[high(rects)].centr.dx:=0;
  rects[high(rects)].centr.dy:=0;
  if col then begin
   rects[high(rects)].color.r:=random(220);
   rects[high(rects)].color.g:=random(220);
   rects[high(rects)].color.b:=random(220);
  end else begin
   rects[high(rects)].color.r:=0;
   rects[high(rects)].color.g:=0;
   rects[high(rects)].color.b:=0;
  end;
  exit;
 end;

 if bal=255 then exit;  //   - 

 if s='V' then begin // Vertical separation
  rec1.Left:=rect.left;
  rec1.Top:=rect.Top;
  rec1.Right:=rect.left+(w div 2);
  rec1.Bottom:=rect.bottom;

  rec2.Left:=rec1.Right+1;
  rec2.Top:=rect.Top;
  rec2.Right:=rect.Right;
  rec2.Bottom:=rect.Bottom;

  if rec1.Right>=rec1.Left then concrete2(rec1,'H');
  if rec2.Right>=rec2.Left then concrete2(rec2,'H');
 end else begin  //  Horizontal separation
  rec1.Left:=rect.Left;
  rec1.Top:=rect.Top;
  rec1.Right:=rect.Right;
  rec1.Bottom:=rect.Top+(h div 2);

  rec2.Left:=rect.Left;
  rec2.Top:=rec1.bottom+1;
  rec2.Right:=rect.Right;
  rec2.Bottom:=rect.Bottom;

  if rec1.bottom>=rec1.top then concrete2(rec1,'V');
  if rec2.bottom>=rec2.top then concrete2(rec2,'V');
 end;
end;

procedure GetMassCenter;
 var i,j,sm:cardinal;
     x,y:extended;
     a,b,d,x1,y1:integer;
begin 
 x:=0;
 y:=0;
 sm:=0;
 if points<>nil then begin
  if tochki then begin  //    
   for i:=0 to high(points) do begin
    x:=x+points[i].x;
    y:=y+points[i].y;
    inc(sm);
   end;
  end else begin     //    
   for i:=0 to high(rects) do begin
    x:=x+rects[i].centr.x*rects[i].centr.mass;
    y:=y+rects[i].centr.y*rects[i].centr.mass;
    sm:=sm+rects[i].centr.mass;
   end;
  end;
  MassCentr.X:=round(x/sm);
  MassCentr.Y:=round(y/sm);
 end;

 MaxFar:=0;
 if points<>nil then begin
  for i:=0 to high(points) do begin
   x:=sqrt(sqr(MassCentr.X-points[i].x)+sqr(MassCentr.Y-points[i].y));
   if x>MaxFar then MaxFar:=round(x);
  end;
  maxfar:=maxfar; // 10 ,  
////////Bresenham's (Pitteway and van Aken) algorithm////////////
  circ:=nil;
  a:=0;
  b:=MaxFar;  //
  d:=3-2*b;
  while(a<=b) do begin
   for i:=0 to 1 do
    for j:=0 to 1 do begin
     x1:=MassCentr.X+a*ar[i];
     y1:=MassCentr.Y+b*ar[j];
     if (y1>0)and(x1>0)and(y1<orh)and(x1<orw) then begin
      setlength(circ,length(circ)+1);
      circ[high(circ)].X:=x1;
      circ[high(circ)].Y:=y1;
     end;

     x1:=MassCentr.X+b*ar[i];
     y1:=MassCentr.Y+a*ar[j];
     if (y1>0)and(x1>0)and(y1<orh)and(x1<orw) then begin
      setlength(circ,length(circ)+1);
      circ[high(circ)].X:=x1;
      circ[high(circ)].Y:=y1;
     end;     
    end;
  if d<0 then d:=d+4*a+8
   else begin
    d:=d+4*(a-b)+10;
    dec(b);
   end;
  inc(a)
  end;
//////////////////////////////////
 end;
end;

end.
