unit Unit2;

interface

uses windows, unit3, jpeg, sysutils, graphics, messages;

procedure OpenPic(FileName:string);
procedure Button3Click;
function GetOpenFileName(var OpenFile: tagOFNA): Bool; stdcall; external 'comdlg32.dll'  name 'GetOpenFileNameA';

implementation

procedure OpenPic(FileName:string);
 var ext:string;
 i,j:integer;
 MyJPEG: TJPEGImage;
begin
 ext:=ExtractFileExt(FileName);
 ext:=LowerCase(ext);
 if ext='.bmp' then begin
  sour.LoadFromFile(FileName);
 end else begin // JPEG
  MyJPEG := TJPEGImage.Create;
  try
   MyJPEG.LoadFromFile(FileName);
   sour.Width:=MyJPEG.Width;
   sour.Height:=MyJPEG.Height;
   sour.Canvas.Draw(0,0,MyJPEG);
  finally
   MyJPEG.Free;
  end;
 end;

 if (sour.width>23)and(sour.Height>23) then begin 
  sour.PixelFormat:=pf24bit;
  orw:=sour.width;
  orh:=sour.Height;
 //////   ///////
  sha:=tbitmap.Create;
  sha.LoadFromResourceName(hinstance,'SH');
  sha.PixelFormat:=pf24bit;
  shad:=sha.Width; ///    
  sha.Height:=shad*2;//    
  sour.Width:=sour.Width+2;  //2   
  sour.Height:=sour.Height+2;
  bitblt(sour.Canvas.Handle,1,1,sour.Width,sour.Height,sour.Canvas.Handle,0,0,srccopy); //   1 ,     
  sour.Canvas.Pen.Width:=1;
  sour.Canvas.Pen.Color:=8486528;
  sour.Canvas.MoveTo(0,0);
  sour.Canvas.LineTo(sour.Width-1,0);
  sour.Canvas.LineTo(sour.Width-1,sour.Height-1);
  sour.Canvas.LineTo(0,sour.Height-1);
  sour.Canvas.LineTo(0,0);
  sour.Width:=sour.Width+shad;
  sour.Height:=sour.Height+shad;

  for i:=((sour.Width-12) div 9) downto 0 do
   bitblt(sour.Canvas.Handle,12+i*9,sour.Height-shad,shad,shad,sha.Canvas.Handle,0,0,srccopy);

  ps:=nil;  //     
  setlength(ps,sha.Height);
  for i:=0 to High(ps) do ps[i]:=sha.scanline[i];

  for i:=0 to shad-1 do   //  -
   for j:=0 to shad-1 do begin
    ps[i+shad,j].r:=ps[j,i].r;
    ps[i+shad,j].g:=ps[j,i].g;
    ps[i+shad,j].b:=ps[j,i].b;
   end;

  for i:=((sour.Height-12) div 9) downto 0 do
   bitblt(sour.Canvas.Handle,sour.Width-shad,12+i*9,shad,shad,sha.Canvas.Handle,0,shad,srccopy);

   for i:=0 to shad-1 do   //  -
   for j:=0 to shad-1 do begin
    ps[j,i].r:=ps[(shad*2)-j-1,i].r;
    ps[j,i].g:=ps[(shad*2)-j-1,i].g;
    ps[j,i].b:=ps[(shad*2)-j-1,i].b;
   end;
  bitblt(sour.Canvas.Handle,sour.Width-shad,sour.Height-shad,shad,shad,sha.Canvas.Handle,0,0,srccopy);
  sha.Free;
/////////  ////////////
  ps:=nil;  //     
  setlength(ps,sour.Height);
  for i:=0 to High(ps) do ps[i]:=sour.scanline[i];

  GetClientRect(mainwnd,r1);
  invalidaterect(mainwnd,@r1,true);
  setwindowtext(mainwnd,pchar(' Reader: '+FileName));
  enablewindow(but2,true);
  enablewindow(but3,true);
  points:=nil;
  rects:=nil;
  circ:=nil;
  for i:=0 to 5 do plot[i]:=0; //  
  plotcount:=0;             //  
  pCOPYcount:=0;
  prevMAXunic:=0;
  setwindowtext(ed1,''); // 
  FillMemory(@b2cap[0],5000,0);
 end else begin
  sour.Width:=0;
  sour.Height:=0;
  enablewindow(but3,false);
  enablewindow(but2,false);
  messagebox(mainwnd,'Picture is too small','Error',MB_OK+MB_ICONWARNING);
 end; 
end;

procedure Button3Click;
 var i,j,b,c,k:cardinal;
 co:trgb;
 mc:extended; // 
begin
 if circle then DrawCircle(255,255,255); //  
////  //////
 wrt.Left:=1; //1 - 
 wrt.Right:=orw;
 wrt.Top:=1;
 wrt.Bottom:=orh;
 co:=GetMid(wrt);
 grt:=wrt;
 inc(grt.Right);//     DrawFrame
 inc(grt.bottom);
 mc:=sqrt(co.r*co.r+co.g*co.g+co.b*co.b);
/////////        //////
 b:=0;
 c:=0;
 for i:=wrt.Top to wrt.Bottom do
  for j:=wrt.Left to wrt.Right do begin
   if sqrt(ps[i,j].r*ps[i,j].r+ps[i,j].g*ps[i,j].g+ps[i,j].b*ps[i,j].b)<mc then
    inc(b) //     
   else
    inc(c);
  end;
 if c>b then begin
  count:=b;
  b:=0;
  c:=255;
 end else begin
  count:=c;
  b:=255;
  c:=0;
 end;

 points:=nil;   //     (      )
 setlength(points,count);

 for i:=0 to high(pointsCOPY) do begin //   
  pointsCOPY[i]:=nil;
  setlength(pointsCOPY[i],count);
 end;

 k:=0;

 for i:=wrt.Top to wrt.Bottom do
  for j:=wrt.Left to wrt.Right do begin
   if sqrt(ps[i,j].r*ps[i,j].r+ps[i,j].g*ps[i,j].g+ps[i,j].b*ps[i,j].b)<mc then begin
    ps[i,j].r:=b;
    ps[i,j].g:=b;
    ps[i,j].b:=b;
    if b=0 then begin
     points[k].x:=j;
     points[k].y:=i;
     points[k].dx:=0;
     points[k].dy:=0;
     points[k].mass:=1;
     inc(k);
    end;
   end else begin
    ps[i,j].r:=c;
    ps[i,j].g:=c;
    ps[i,j].b:=c;
    if c=0 then begin
     points[k].x:=j;
     points[k].y:=i;
     points[k].dx:=0;
     points[k].dy:=0;
     points[k].mass:=1;
     inc(k);
    end;
   end;
  end;

 if tochki=false then begin
  rects:=nil;

  if square then
   Concrete(wrt)  //     
  else
   Concrete2(wrt,'V');  //  -  
 end;
 
 if tochki then //    
  setwindowtext(mainwnd,pchar('points - '+inttostr(length(points))))
 else
  if square then
   setwindowtext(mainwnd,pchar('squares - '+inttostr(length(rects))))
  else
   setwindowtext(mainwnd,pchar('rects - '+inttostr(length(rects))));
end;

end.
